using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;


namespace NestedTableHide
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl WidgetGroupingGrid;
        private NestedTableHide.WidgetDataSet WidgetData;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
            GridEngineFactory.Factory = new CustomGroupingEngineFactory();

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor gridColumnDescriptor1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor();
            Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor gridColumnDescriptor2 = new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor();
            this.WidgetGroupingGrid = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.WidgetData = new NestedTableHide.WidgetDataSet();
            ((System.ComponentModel.ISupportInitialize)(this.WidgetGroupingGrid)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.WidgetData)).BeginInit();
            this.SuspendLayout();
            // 
            // WidgetGroupingGrid
            // 
            this.WidgetGroupingGrid.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.WidgetGroupingGrid.BackColor = System.Drawing.SystemColors.Window;
            this.WidgetGroupingGrid.DataMember = "Widget";
            this.WidgetGroupingGrid.DataSource = this.WidgetData;
            this.WidgetGroupingGrid.Location = new System.Drawing.Point(8, 8);
            this.WidgetGroupingGrid.Name = "WidgetGroupingGrid";
            this.WidgetGroupingGrid.Size = new System.Drawing.Size(520, 344);
            this.WidgetGroupingGrid.TabIndex = 0;
            gridColumnDescriptor1.MappingName = "Name";
            gridColumnDescriptor1.Width = 150;
            gridColumnDescriptor2.Appearance.AnyRecordFieldCell.CellType = "ComboBox";
            gridColumnDescriptor2.Appearance.AnyRecordFieldCell.DataSource = this.WidgetData.WidgetType;
            gridColumnDescriptor2.Appearance.AnyRecordFieldCell.DisplayMember = "Name";
            gridColumnDescriptor2.Appearance.AnyRecordFieldCell.ValueMember = "WidgetTypeID";
            gridColumnDescriptor2.HeaderText = "Widget Type";
            gridColumnDescriptor2.MappingName = "WidgetTypeID";
            gridColumnDescriptor2.Width = 150;
            this.WidgetGroupingGrid.TableDescriptor.Columns.AddRange(new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor[] {
                                                                                                                                           gridColumnDescriptor1,
                                                                                                                                           gridColumnDescriptor2});
            this.WidgetGroupingGrid.Text = "gridGroupingControl1";
            this.WidgetGroupingGrid.VersionInfo = "4.101.0.63";
            // 
            // WidgetData
            // 
            this.WidgetData.DataSetName = "WidgetDataSet";
            this.WidgetData.Locale = new System.Globalization.CultureInfo("en-US");
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(544, 389);
            this.Controls.Add(this.WidgetGroupingGrid);
            this.Name = "MainForm";
            this.Text = "Widget Grouping Example";
            this.Load += new System.EventHandler(this.MainForm_Load);
            ((System.ComponentModel.ISupportInitialize)(this.WidgetGroupingGrid)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.WidgetData)).EndInit();
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}


        private void LoadData() 
        {
            // We only want to show the WidgetMaintenanceLog child table for "Industrial Widgets"
            WidgetDataSet.WidgetTypeRow industrialWidgetTypeRow = this.WidgetData.WidgetType.NewWidgetTypeRow();
            industrialWidgetTypeRow.WidgetTypeID = 1;
            industrialWidgetTypeRow.Name = "Industrial Widget";
            this.WidgetData.WidgetType.AddWidgetTypeRow(industrialWidgetTypeRow);

            // We DO NOT want to show the WidgetMaintenanceLog for "Toy Widgets"
            WidgetDataSet.WidgetTypeRow toyWidgetTypeRow = this.WidgetData.WidgetType.NewWidgetTypeRow();
            toyWidgetTypeRow.WidgetTypeID = 2;
            toyWidgetTypeRow.Name = "Toy Widget";
            this.WidgetData.WidgetType.AddWidgetTypeRow(toyWidgetTypeRow);

            // The user should be able to add maintenance log entries for this Bulldozer
            WidgetDataSet.WidgetRow widgetRow = this.WidgetData.Widget.NewWidgetRow();
            widgetRow.Name = "Bulldozer";
            widgetRow.WidgetTypeRow = industrialWidgetTypeRow;
            this.WidgetData.Widget.AddWidgetRow(widgetRow);

            // The user should NOT be able to add maintenance log entries for this Tonka Truck
            // Futher, we do not even want to show the WidgetMaintenanceLog child table for this item 
            // because its WidgetTypeID is set to 2.
            widgetRow = this.WidgetData.Widget.NewWidgetRow();
            widgetRow.Name = "Tonka Truck";
            widgetRow.WidgetTypeRow = toyWidgetTypeRow;
            this.WidgetData.Widget.AddWidgetRow(widgetRow);   
        }


        private void MainForm_Load(object sender, System.EventArgs e)
        {
            this.LoadData();
        }
	}
}
